;***
;
; Copyright (c) 2008 ӢʱƼ޹˾Ȩ
;
; ֻ EOS ԴЭ飨μ License.txtеʹЩ롣
; ܣʹЩ롣
;
; ļ: loader.asm
;
; : ںˡ
;
; 
;
;*******************************************************************************/


; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;                               loader.asm

; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
; ʱBIOS  512 ֽڵص 0000:0x7C00 ʼִУȻ
; ٰ Loader.bin ص 0000:0x1000 ʼִС
; ǽ5120дӲ̵һ
;

	org 0x1000
	jmp	Start

buffer      times 512 db     0                     ;׼һ
ide_command_base_addr      equ    01f0h            ;IDE豸ģĴַ

;***************************Ĵַ****************************************
;      Port    Read/Write   Misc
;    --------  ----------   ------------------------------------
;       1f0       r/w       data register, the bytes are written/read here
;       1f1       r         error register  (look these values up yourself)
;       1f2       r/w       sector count, how many sectors to read/write
;       1f3       r/w       sector number, the actual sector wanted
;       1f4       r/w       cylinder low, cylinders is 0-1024
;       1f5       r/w       cylinder high, this makes up the rest of the 1024
;       1f6       r/w       drive/head
;                              bit 7 = 1
;                              bit 6 = 0
;                              bit 5 = 1
;                              bit 4 = 0  drive 0 select
;                                    = 1  drive 1 select
;                              bit 3-0    head select bits
;       1f7       r         status register
;                              bit 7 = 1  controller is executing a command
;                              bit 6 = 1  drive is ready
;                              bit 5 = 1  write fault
;                              bit 4 = 1  seek complete
;                              bit 3 = 1  sector buffer requires servicing
;                              bit 2 = 1  disk data read corrected
;                              bit 1 = 1  index - set to 1 each revolution
;                              bit 0 = 1  previous command ended in an error
;       1f7       w         command register
;                            commands:
;                              50h format track
;                              20h read sectors with retry
;                              21h read sectors without retry
;                              22h read long with retry
;                              23h read long without retry
;                              30h write sectors with retry
;                              31h write sectors without retry
;                              32h write long with retry
;                              33h write long without retry
;
;  Most of these should work on even non-IDE hard disks.   
;*****************************************************************************
Start:

    mov ax, cs                                        ;ȫ0
	mov ds, ax
	mov es, ax

	mov     dx,ide_command_base_addr+6                ;Drive and head port
    mov     al,0a0h                                   ;Drive 0, head 0
    out     dx,al

    mov     dx,ide_command_base_addr+2                ;Sector count port
    mov     al,1                                      ;Write one sector
    out     dx,al                                     ;

    mov     dx,ide_command_base_addr+3                ;Sector number port
    mov     al,1                                      ;Wrote to sector one
    out     dx,al

    mov     dx,ide_command_base_addr+4                ;Cylinder low port
    mov     al,0                                      ;Cylinder 0
    out     dx,al                                     ;ĵ8λ

    mov     dx,ide_command_base_addr+5                ;Cylinder high port
    mov     al,0                                      ;The rest of the cylinder 0
    out     dx,al                                     ;ĸ8λ

    mov     dx,ide_command_base_addr+7                ;Command port
    mov     al,30h                                    ;Write with retry.
    out     dx,al

    
busy_wait:     
    in      al,dx                                     ;dx=1f7h
    test    al,8                                      ;Wait for sector buffer ready.
    jz      busy_wait                                 ;æʱȴ
    
    mov     cx,512/2                                  ;One sector /2
    mov     si,buffer;
    mov     dx,1f0h                                   ;Data port - data comes in and out of here.
    rep     outsw                                     ;д˿01f0hÿһ
       
over:                                                 ;ѭ
    jmp over
